Imports System
Imports System.Numerics ' must add Reference to project

Namespace SignTestUsingVB
    Friend Class SignTestProgram
        Shared Sub Main(ByVal args() As String)
            Console.WriteLine(vbCrLf & "Begin Sign Test demo " & vbCrLf)
            Console.WriteLine("Goal is to determine if weight loss program has an effect " & vbCrLf)

            Dim before() As Double = {70, 80, 75, 85, 70, 75, 50, 60}
            Dim after() As Double = {65, 78, 72, 87, 68, 74, 48, 63}
            '                               +   +   +   -   +   +   +   -   

            Console.WriteLine("The weight data is: " & vbCrLf)
            ShowVector("Before:  ", before, 0, "")
            ShowVector("After :  ", after, 0, vbCrLf)

            Dim counts() As Integer = DoCounts(before, after)
            Console.WriteLine("Num success = " & counts(2))
            Console.WriteLine("Num failure = " & counts(0))

            Console.WriteLine(vbCrLf & "Calling program-defined BinomRightTail() function " & vbCrLf)
            Dim k As Integer = counts(2) ' successes
            Dim n As Integer = counts(0) + counts(2) ' success + fail
            Console.WriteLine("k = " & k & " n = " & n & " p = 0.5")
            Dim p_value As Double = BinomRightTail(k, n, 0.5)

            Console.WriteLine(vbCrLf & "Probability of 'no effect' is " & p_value.ToString("F4"))
            Console.WriteLine("Probability of 'an effect' is " & (1 - p_value).ToString("F4"))

            Console.WriteLine(vbCrLf & vbCrLf & "End Sign Test demo " & vbCrLf)
            Console.ReadLine()
        End Sub ' Main

        Private Shared Function DoCounts(ByVal before() As Double, ByVal after() As Double) As Integer()
            Dim result(2) As Integer ' 0 = fail, 1 = neither, 2 = success
            For i = 0 To before.Length - 1
                If after(i) > before(i) Then
                    result(0) += 1 ' fail
                ElseIf after(i) < before(i) Then
                    result(2) += 1
                Else
                    result(1) += 1
                End If
            Next i
            Return result
        End Function

        Private Shared Sub ShowVector(ByVal pre As String, ByVal v() As Double, ByVal dec As Integer, ByVal post As String)
            Console.Write(pre)
            For i = 0 To v.Length - 1
                Console.Write(v(i).ToString("F" & dec) & " ")
            Next i
            Console.WriteLine(post)
        End Sub

        Private Shared Function BinomProb(ByVal k As Integer, ByVal n As Integer, ByVal p As Double) As Double
            ' probability of getting k "successes" in n trials
            ' if p is prob of success on a single trial
            Dim c As BigInteger = Choose(n, k)
            Dim left As Double = Math.Pow(p, k)
            Dim right As Double = Math.Pow(1.0 - p, n - k)
            Return CDbl(c) * left * right
        End Function

        Private Shared Function BinomRightTail(ByVal k As Integer, ByVal n As Integer, ByVal p As Double) As Double
            ' probability of getting k or more successes in n trials
            Dim sum As Double = 0.0
            For i = k To n
                sum += BinomProb(i, n, p)
            Next i
            Return sum
        End Function

        Private Shared Function Choose(ByVal n As Integer, ByVal k As Integer) As BigInteger
            'If n < 0 OrElse k < 0 Then
            '    Throw New Exception("Negative argument in Choose")
            'End If
            'If n < k Then ' special case
            '    Return 0
            'End If
            'If k = 0 Then ' special case
            '    Return 1
            'End If
            If n = k Then ' required special case
                Return 1
            End If

            Dim delta, iMax As Integer

            If k < n - k Then ' ex: Choose(100,3)
                delta = n - k
                iMax = k
            Else ' ex: Choose(100,97)
                delta = k
                iMax = n - k
            End If

            Dim ans As BigInteger = delta + 1
            For i = 2 To iMax
                ans = (ans * (delta + i)) / i
            Next i

            Return ans
        End Function ' Choose
    End Class ' Program
End Namespace ' ns
